﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Data;
using System.Diagnostics;
using System.Data.SqlClient;
using MVCsampleSQL.Models;
using System.Web.Configuration;
using System.Web.Script.Serialization;
using System.Web.Script.Services;

namespace MVCsampleSQL.Controllers
{
    public class GanttData
    {
        public object StartDate { get; set; }
        public string TaskId { get; set; }
        public int ID { get; set; }
        public string Name { get; set; }
        public string EndDate { get; set; }
        public string Duration { get; set; }
        public string PercentDone { get; set; }
        public List<string> ResourceID { get; set; }        
        public string ParentId { get; set; }
        public string Predescessor { get; set; }

    }
    public class myDropDown
    {
        public string ResourceID { get; set; }
        public string ddtext { get; set; }
    }

    public class GanttController : Controller
    {
        //
        // GET: /Gantt/
        string connectionString;
        public ActionResult Index()
        {
            List<GanttData> list = new List<GanttData>();
            connectionString = string.Format(@"Data Source=(LocalDB)\v11.0;AttachDbFilename=" + Server.MapPath("App_Data") + @"\GanttDataSource.mdf;Integrated Security=True;Connect Timeout=30");
            SqlConnection conn = new SqlConnection(WebConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString);

            conn.Open();

            using (conn)
            {
                using (var command = conn.CreateCommand())
                {
                    command.CommandText = "SELECT * FROM GanttData1";

                    using (var reader = command.ExecuteReader())
                    {
                        var indexOfCol1 = reader.GetOrdinal("ID");
                        var indexOfCol2 = reader.GetOrdinal("TaskId");
                        var indexOfCol3 = reader.GetOrdinal("TaskName");
                        var indexOfCol4 = reader.GetOrdinal("StartDate");
                        var indexOfCol5 = reader.GetOrdinal("EndDate");
                        var indexOfCol6 = reader.GetOrdinal("Progress");
                        var indexOfCol7 = reader.GetOrdinal("Duration");
                        var indexOfCol8 = reader.GetOrdinal("ParentId");
                        var indexOfCol9 = reader.GetOrdinal("Resource");

                        while (reader.Read())
                        {
                            GanttData obj = new GanttData();
                            obj.ID = reader.GetInt32(indexOfCol1);
                            obj.TaskId = reader.GetValue(indexOfCol2).ToString();
                            obj.ParentId = reader.GetValue(indexOfCol8).ToString();
                            obj.Name = reader.GetValue(indexOfCol3).ToString();
                            obj.PercentDone = reader.GetValue(indexOfCol6).ToString();
                            obj.StartDate = reader.GetValue(indexOfCol4).ToString();
                            obj.EndDate = reader.GetValue(indexOfCol5).ToString();
                            obj.ResourceID = this.GetResourceValues(reader.GetValue(indexOfCol9).ToString());
                            list.Add(obj);
                        }
                        reader.Close();
                    }
                }
                conn.Close();

            }
            ViewBag.dataSource = list;
            var resource=dropdown();
            ViewBag.resources = resource;
            return View();
        }
        public List<string> GetResourceValues(string resourceArr)
        {
            List<string> Arr = new List<string>();
            string[] resourceId = resourceArr.Split(',');
            IEnumerable<object> dropdownData = dropdown();
            List<myDropDown> resultData = dropdownData as List<myDropDown>;
            foreach (var id in resourceId)
            {
                foreach (var data in resultData)
                {
                    if (id == data.ResourceID)
                    {
                        Arr.Add(data.ResourceID);
                    }
                }
            }
            return Arr;
        }

        public static IEnumerable<object> dropdown()
        {
            // instantiate a serializer
            JavaScriptSerializer TheSerializer = new JavaScriptSerializer();
            List<myDropDown> resourceDetails = new List<myDropDown>();
            resourceDetails.Add(new myDropDown() { ResourceID = "1", ddtext = "Project Manager" });
            resourceDetails.Add(new myDropDown() { ResourceID = "2", ddtext = "Software Analyst" });
            resourceDetails.Add(new myDropDown() { ResourceID = "3", ddtext = "Developer" });
            resourceDetails.Add(new myDropDown() { ResourceID = "4", ddtext = "Testing Engineer" });
            var resourceList = resourceDetails.ToList();
            var theJson = TheSerializer.Serialize(resourceDetails);
            return resourceList;
        }       

        [HttpPost()]
        public void Update(GanttData Task, List<myDropDown> Resource)
        {
            //Update Edited TaskDetails
            //Using UPDATE SQL Query to Save the Modified taskData into the Table

            connectionString = string.Format(@"Data Source=(LocalDB)\v11.0;AttachDbFilename=" + Server.MapPath("App_Data") + @"\GanttDataSource.mdf;Integrated Security=True;Connect Timeout=30");

            string IDNumber = Task.TaskId;

            string cmdString = "UPDATE GanttData1 SET TaskId=@TaskId, TaskName=@TaskName,StartDate=@StartDate,EndDate=@EndDate,Duration=@Duration, Resource=@Resource, Progress=@Progress,ParentId=@ParentId,Predecessor=@Predecessor WHERE TaskId = '" + IDNumber + "'";

            SqlConnection con = new SqlConnection(WebConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString);//connectionString

            con.Open();
            using (SqlCommand sqlCommand = new SqlCommand(cmdString, con))
            {
                sqlCommand.Parameters.AddWithValue("@TaskName", Task.Name);
                sqlCommand.Parameters.AddWithValue("@StartDate", Task.StartDate);
                sqlCommand.Parameters.AddWithValue("@TaskId", Task.TaskId);
                sqlCommand.Parameters.AddWithValue("@EndDate", Task.EndDate);
                sqlCommand.Parameters.AddWithValue("@Progress", Task.PercentDone);
                sqlCommand.Parameters.AddWithValue("@Resource", this.GetResourceId(Resource));  
                if (Task.Duration == null)
                {
                    sqlCommand.Parameters.AddWithValue("@Duration", Task.Duration).Value = "0";
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@Duration", Task.Duration);
                }
                if (Task.ParentId == null)
                {
                    sqlCommand.Parameters.AddWithValue("@ParentId", Task.ParentId).Value = "0";
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@ParentId", Task.ParentId);
                }
                if (Task.Predescessor == null)
                {
                    sqlCommand.Parameters.AddWithValue("@Predecessor", Task.Predescessor).Value = "";
                }
                else
                {
                    sqlCommand.Parameters.AddWithValue("@Predecessor", Task.Predescessor);
                }

                sqlCommand.ExecuteNonQuery();
            }

            con.Close();
        }

        public string GetResourceId(List<myDropDown> Resources)
        {
            string text = "";
            bool isResourcePresent = true;
            if (Resources == null)
                isResourcePresent = false;
            if (Resources != null && (Resources.Count == 0 || Resources[0] == null))
                isResourcePresent = false;
            if (isResourcePresent)
            {
                foreach (var i in Resources)
                {
                    string changetext = i.ResourceID;
                    text += changetext + ",";
                }
            }
            return text;
        }

    }
}
